using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel.Composition;
using System.Runtime.InteropServices;

using SlimDX;
using SlimDX.Direct3D11;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.DX11.Nodes;

using VVVV.Utils;

using FeralTic;
using FeralTic.DX11.Resources;


namespace VVVV.Nodes.DX11
{
    [StructLayout(LayoutKind.Sequential)]
    public struct Attractor3d
    {
        public Vector3 Position;
        public float Power;
    	public float Strenght;
        public float Radius;
    }

    [PluginInfo(Name = "DynamicBuffer", Category = "DX11", Version = "Attractor 3d", Author = "antokhio")]
    public class Attractor3dBuffer : DynamicArrayBuffer<Attractor3d>
    {
        [Input("Position", AutoValidate = false)]
        protected ISpread<Vector3> FPosition;

        [Input("Power", AutoValidate = false)]
        protected ISpread<float> FPow;
    	
    	[Input("Strenght", AutoValidate = false, DefaultValue = 1)]
        protected ISpread<float> FStr;

        [Input("Radius", AutoValidate = false, DefaultValue = 1)]
        protected ISpread<float> FRadius;
	
        protected override void BuildBuffer(int count, Attractor3d[] buffer)
        {
            this.FPosition.Sync();
        	this.FPow.Sync();
            this.FStr.Sync();
            this.FRadius.Sync();

            for (int i = 0; i < count; i++)
            {

                buffer[i].Position = this.FPosition[i];
                buffer[i].Power = this.FPow[i];
            	buffer[i].Strenght = this.FStr[i];
                buffer[i].Radius = this.FRadius[i];
            }
        }
    }
}

